# --------------------------------------------------------------------------
# This is the script to create the unicode chars property table 
# Written by Dimitry Golubovsky (dimitry@golubovsky.org) as part
# of the Partial Unicode Support patch
#
# Adopted for use with GHC.
# License: see LICENSE.BSD3
#
# Adapted for Clean and translated to powershell
#
# -------------------------------------------------------------------------

#	The script reads the filepath from the first argument,
#	and outputs C code to the filepath on the second argument.
#	The C code contains the chars property table, and basic functions
#	to access properties.

param (
	[string]$infile = $( Read-Host "Input file, please" ),
	[string]$outfile = $( Read-Host "Output file, please" )
)

#	Output the file header
Write-Output @"
/*-------------------------------------------------------------------------
This is an automatically generated file: do not edit
Generated by .\ubconfc.ps1 at $(Get-Date)
-------------------------------------------------------------------------*/
"@ | Add-Content -Path $outfile

# Define structures
Get-Content WCsubst.c.pre | Add-Content -Path $outfile

# Convert the stdin file to the C table
awk -f ubconfc.awk $infile | Add-Content -Path $outfile

# Output C procedures code
Get-Content WCsubst.c.post | Add-Content -Path $outfile
